/* global.h - For the system call fuzz generator. */
#ifndef GLOBAL_H
#define GLOBAL_H

#ifndef MAKE_DEFINITIONS
#define EXTERN
#else
#define EXTERN extern
#endif


/***********************************************************************
Global variables.  Many store command-line parameters.
***********************************************************************/

/* This is the name and handle for the file containing information about
the system calls to be tested. */
EXTERN char *CallFileName;
EXTERN FILE *CallFile;

/* This is the list of system calls to be fuzzed. */
EXTERN int NSysCall;
EXTERN SysCallT SysCall[MAX_SYSCALLS];

/* This is the information about the tests to be performed. */
EXTERN int NTest;

/* This is the information about the summary file. */
EXTERN int SummaryFlag;
EXTERN char *SummaryFileName;
EXTERN FILE *SummaryFile;

/* This is the information about the logging file. */
EXTERN int LoggingFlag;
EXTERN char *LogFileName;
EXTERN FILE *LogFile;

/* This is the information about the parameters to be passed to each call. */
EXTERN int MaxParameters;

/* This is the random number generator's current state. */
EXTERN unsigned short Rand48State[3];

/* This flag is turned on if we are using the aggressive method of
system call testing. */
EXTERN int AggressiveFlag;

/* This is parameter space for the aggressive implementation. */
EXTERN int ParameterSpace[MAX_PARAMETERS][PARAMETER_SPACE_SIZE];

/* If this is set, catch and ignore SIGSEGV signals. */
EXTERN int CatchSIGSEGVFlag;

/* This flag causes each system call to be output to stdout. */
EXTERN int PrintEachTestFlag;

/* These values control the announcement of each n system calls.  This
gives the user a chance to realize that the system is locked-up. */
EXTERN int AnnounceTestsFlag;
EXTERN int AnnounceTestsEach;

/* This flag causes the fuzz tool to send a SIGUSR1 to its parent upon
successful completion of all tests. */
EXTERN int SignalParent;

#endif
