/* main.h - For the system call fuzz generator. */
#ifndef MAIN_H
#define MAIN_H

/* This echos the command-line options to the standard output. */

#define ECHO_OPTIONS

/* This echos the system call found in the input file to the standard
output. */

/*#define ECHO_SYSCALLS*/

/* This outputs the number of system calls found in the input file to
the standard output. */

#define PRINT_NUMBER_OF_SYSCALLS_FOUND

/* If INSERT_INNOCUOUS_SYSCALL is defined, before each "real" system
call, some innocuous system call is made.  This seems to affect the
kernel state between calls in some way that makes the system more
stable.  This may also work with simply a printf()! */

/*#define INSERT_INNOCUOUS_SYSCALL*/

/* This should be included when information about the average time
required per system call is wanted.  This will only work on a Solaris
machine.  It is defined automatically when you use "make fuzz-timer" */

/* #define INCLUDE_TIMER */

/* This is the maximum number of system calls that will appear in the
system call input file. */

#define MAX_SYSCALLS	1000

/* The maximum number of parameters to pass to a system call can be set
with a command line option.  This is an absolute upper limit.  If this
is made larger than 10, code in tests.c will have to be updated. */

#define MAX_PARAMETERS	8

/* This is the size of each parameter's space in 4-byte int's.  This
region is currently set to a string of random 32 bit values, with each
pointer parameter pointing to its own space, which is the given size.
The entire parameter space is PARAMETER_SPACE_SIZE * MAX_PARAMETERS. */

#define PARAMETER_SPACE_SIZE 16

/* This must be defined for the aggressive randomization to actually
randomize the area pointed to by the identified pointer arguments. */
#define INCLUDE_CODE_FOR_AGGRESSIVE_RANDOMIZATION

#define TRUE	1
#define FALSE	0

/* Generate a random number between m and n inclusive. */
#include <stdlib.h>
#define RAND(m, n) (int)((drand48() * (n-(m-1))) + m)


/* Note:  The parameter flags are not easy to construct.  As a result,
they are currently ignored.  When the aggressive mode is turned on, all
parameters are assumed to be pointers. */

typedef struct {
  int num;		/* The number of the call. */
  char name[30];	/* The name of the system call. */

  /* These are the parameter flags.  0 - not a pointer, 1 - a pointer. */
  int parmFlag[MAX_PARAMETERS];
} SysCallT;


void clean_up();
void write_summary_done(void);

#endif
